Loading...
Searching...
No Matches
casacore::FITSErrorImage Class Reference
images package (libcasa_images) » Images_module

More...

`#include <FITSErrorImage.h>`

## Public Types

enum | ErrorType { MSE , RMSE , INVMSE , INVRMSE , UNKNOWN , DEFAULT }
| The enum describes which types of error images exist. More...

## Public Member Functions

| FITSErrorImage (const String &name, uInt whichRep=0, uInt whichHDU=0, FITSErrorImage::ErrorType errtype=MSE)
| Construct a FITSImage from the disk FITS file name and extension and apply mask.
| FITSErrorImage (const String &name, const MaskSpecifier &mask, uInt whichRep=0, uInt whichHDU=0, FITSErrorImage::ErrorType errtype=MSE)
| Construct a FITSImage from the disk FITS file name and extension and apply mask or not.
| FITSErrorImage (const FITSErrorImage &other)
| Copy constructor (reference semantics).
virtual | ~FITSErrorImage ()
| Destructor.
FITSErrorImage & | operator= (const FITSErrorImage &other)
| Assignment (reference semantics).
virtual ImageInterface< Float > * | cloneII () const
| Make a copy of the object with new (reference semantics).
virtual String | imageType () const
| Get the image type (returns "FITSErrorImage").
virtual Bool | doGetSlice (Array< Float > &buffer, const Slicer &theSlice)
| Do the actual get of the data.
virtual void | doPutSlice (const Array< Float > &sourceBuffer, const IPosition &where, const IPosition &stride)
| The FITSImage is not writable, so this throws an exception.
virtual FITSErrorImage::ErrorType | errorType () const
| Return the error type.
Public Member Functions inherited from casacore::FITSImage
| FITSImage (const String &name, uInt whichRep=0, uInt whichHDU=0)
| Construct a FITSImage from the disk FITS file name and extension and apply mask.
| FITSImage (const String &name, const MaskSpecifier &mask, uInt whichRep=0, uInt whichHDU=0)
| Construct a FITSImage from the disk FITS file name and extension and apply mask or not.
| FITSImage (const FITSImage &other)
| Copy constructor (reference semantics).
virtual | ~FITSImage ()=default
| Destructor does nothing.
FITSImage & | operator= (const FITSImage &other)
| Assignment (reference semantics).
virtual void | resize (const TiledShape &newShape)
| Function which changes the shape of the FITSImage.
virtual Bool | isMasked () const
| Has the object really a mask?
virtual Bool | hasPixelMask () const
| FITSimage always has a pixel mask so returns True.
virtual const Lattice< Bool > & | pixelMask () const
| Get access to the pixelmask.
virtual Lattice< Bool > & | pixelMask ()
virtual Bool | doGetMaskSlice (Array< Bool > &buffer, const Slicer &section)
| Do the actual get of the mask data.
virtual const LatticeRegion * | getRegionPtr () const
| Get the region used.
virtual Bool | isPaged () const
| The lattice is paged to disk.
virtual Bool | isPersistent () const
| The lattice is persistent.
virtual Bool | isWritable () const
| The FITSImage is not writable.
virtual String | name (Bool stripPath=False) const
| Returns the name of the disk file.
virtual IPosition | shape () const
| return the shape of the FITSImage
virtual uInt | advisedMaxPixels () const
| Returns the maximum recommended number of pixels for a cursor.
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| Help the user pick a cursor for most efficient access if they only want pixel values and don't care about the order or dimension of the cursor.
virtual void | tempClose ()
| Temporarily close the image.
virtual void | reopen ()
| Reopen a temporarily closed image.
virtual Bool | ok () const
| Check class invariants.
virtual DataType | dataType () const
| Return the data type (TpFloat).
DataType | internalDataType () const
| Return the (internal) data type.
uInt | whichHDU () const
| Return the HDU number.
virtual uInt | maximumCacheSize () const
| Maximum size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be be big enough for the indicated number of tiles.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.
Public Member Functions inherited from casacore::ImageInterface< Float >
| ImageInterface ()
virtual | ~ImageInterface ()
virtual MaskedLattice< Float > * | cloneML () const
| Make a copy of the derived object (reference semantics).
virtual Bool | setUnits (const Unit &newUnits)
| Function which get and set the units associated with the image pixels (i.e.
virtual const Unit & | units () const
virtual Bool | setCoordinateInfo (const CoordinateSystem &coords)
| Functions to set or replace the coordinate information in the Image Returns False on failure, e.g.
const CoordinateSystem & | coordinates () const
virtual LELCoordinates | lelCoordinates () const
| Function to get a LELCoordinate object containing the coordinates.
LoggerHolder & | logger ()
| Get access to the LoggerHolder.
LogIO & | logSink ()
| Allow messages to be logged to this ImageInterface.
void | appendLog (const LoggerHolder &other)
| Add the messages from the other image logger to this one.
const TableRecord & | miscInfo () const
| Often we have miscellaneous information we want to attach to an image.
virtual Bool | setMiscInfo (const RecordInterface &newInfo)
const ImageInfo & | imageInfo () const
| The ImageInfo object contains some miscellaneous information about the image which unlike that stored in MiscInfo, has a standard list of things, such as the restoring beam.
ImageInfo & | rwImageInfo ()
| Get non-const access to the ImageInfo.
virtual Bool | setImageInfo (const ImageInfo &info)
virtual ImageAttrHandler & | attrHandler (Bool createHandler=False)
| Get access to the attribute handler.
ImageAttrHandler & | roAttrHandler () const
Bool | canDefineRegion () const
| Can the image handle region definition?
virtual ImageRegion | makeMask (const String &name, Bool defineAsRegion=True, Bool setAsDefaultMask=True, Bool initialize=False, Bool value=True)
| Make a mask which is suitable for the type of image.
virtual void | defineRegion (const String &name, const ImageRegion &region, RegionHandler::GroupType, Bool overwrite=False)
| Define a region/mask belonging to the image.
virtual Bool | hasRegion (const String &regionName, RegionHandler::GroupType=RegionHandler::Any) const
| Does the image have a region with the given name?
virtual ImageRegion * | getImageRegionPtr (const String &name, RegionHandler::GroupType=RegionHandler::Any, Bool throwIfUnknown=True) const
| Get a region/mask belonging to the image from the given group (which can be Any).
virtual void | renameRegion (const String &newName, const String &oldName, RegionHandler::GroupType=RegionHandler::Any, Bool overwrite=False)
| Rename a region.
virtual void | removeRegion (const String &name, RegionHandler::GroupType=RegionHandler::Any, Bool throwIfUnknown=True)
| Remove a region/mask belonging to the image from the given group (which can be Any).
virtual Vector< String > | regionNames (RegionHandler::GroupType=RegionHandler::Any) const
| Get the names of all regions/masks.
virtual void | useMask (MaskSpecifier=MaskSpecifier())
| Use the mask as specified.
virtual void | setDefaultMask (const String &regionName)
| Set the default pixelmask to the mask with the given name (which has to exist in the "masks" group).
virtual String | getDefaultMask () const
| Get the name of the default pixelmask.
ImageRegion | getRegion (const String &regionName, RegionHandler::GroupType=RegionHandler::Any) const
| Get a region belonging to the image.
String | makeUniqueRegionName (const String &rootName, uInt startNumber=1) const
| Make a unique region name from the given root name, thus make it such that the name is not already in use for a region or mask.
Bool | toRecord (String &error, RecordInterface &outRec)
| Save and restore an ImageInterface object to or from a state Record.
Bool | fromRecord (String &error, const RecordInterface &inRec)
Public Member Functions inherited from casacore::MaskedLattice< Float >
| MaskedLattice ()
| Default constructor.
virtual | ~MaskedLattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual Lattice< Float > * | clone () const
| Make a copy of the derived object (reference semantics).
const LatticeRegion & | region () const
| Get the region used.
Bool | getMask (COWPtr< Array< Bool > > &buffer, Bool removeDegenerateAxes=False) const
| Get the mask or a slice from the mask.
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Public Member Functions inherited from casacore::Lattice< Float >
virtual | ~Lattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
Float | operator() (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
virtual Float | getAt (const IPosition &where) const
virtual void | putAt (const Float &value, const IPosition &where)
| Put the value of a single element.
Bool | get (COWPtr< Array< Float > > &buffer, Bool removeDegenerateAxes=False) const
| Functions which extract an Array of values from a Lattice.
Bool | getSlice (COWPtr< Array< Float > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
void | putSlice (const Array< Float > &sourceBuffer, const IPosition &where, const IPosition &stride)
| A function which places an Array of values within this instance of the Lattice at the location specified by the IPosition "where", incrementing by "stride".
void | put (const Array< Float > &sourceBuffer)
virtual void | set (const Float &value)
| Set all elements in the Lattice to the given value.
virtual void | apply (Float(*function)(Float))
| Replace every element, x, of the Lattice with the result of f(x).
void | operator+= (const Lattice< Float > &other)
| Add, subtract, multiple, or divide by another Lattice.
void | operator-= (const Lattice< Float > &other)
void | operator*= (const Lattice< Float > &other)
void | operator/= (const Lattice< Float > &other)
virtual void | copyData (const Lattice< Float > &from)
| Copy the data from the given lattice to this one.
virtual void | copyDataTo (Lattice< Float > &to) const
| Copy the data from this lattice to the given lattice.
virtual LatticeIterInterface< Float > * | makeIter (const LatticeNavigator &navigator, Bool useRef) const
| These functions are used by the LatticeIterator class to generate an iterator of the correct type for a specified Lattice.
Public Member Functions inherited from casacore::LatticeBase
virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual Bool | canReferenceArray () const
| Can the lattice data be referenced as an array section?
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| It is strongly recommended to use class LatticeLocker to handle lattice locking.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the Lattice object with the lattice file.
virtual void | flush ()
| Flush the data (but do not unlock).
virtual uInt | ndim () const
| Return the number of axes in this Lattice.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const

## Static Public Member Functions

static FITSErrorImage::ErrorType | stringToErrorType (String errorTypeStr)
| Convert an image type to String.
static String | errorTypeToString (FITSErrorImage::ErrorType errType)
| Convert a String to an image type.
Static Public Member Functions inherited from casacore::FITSImage
static LatticeBase * | openFITSImage (const String &name, const MaskSpecifier &)
| Function to open a FITS image (new parser).
static void | registerOpenFunction ()
| Register the open function.
static String | get_fitsname (const String &fullname)
| Separate any extension specification and return the pure fitsname.
static uInt | get_hdunum (const String &fullname)
| Get the extension index for any extension specification given in the full name.
static String | className ()
| returns "FITSImage".

## Private Member Functions

void | setupMask ()
| Set the correct masking.

## Private Attributes

Array< Float > | buffer_p
FITSErrorImage::ErrorType | errtype_p

## Additional Inherited Members

Protected Member Functions inherited from casacore::FITSImage
void | setMaskZero (Bool filterZero)
| Set the masking of values 0.0.
Protected Member Functions inherited from casacore::ImageInterface< Float >
ImageInterface & | operator= (const ImageInterface &other)
| Assignment (copy semantics) is only useful for derived classes.
Bool | restoreImageInfo (const RecordInterface &rec)
| Restore the image info from the record.
void | setLogMember (const LoggerHolder &logger)
| Set the image logger variable.
void | setImageInfoMember (const ImageInfo &imageInfo)
| Set the image info variable.
void | setCoordsMember (const CoordinateSystem &coords)
| Set the coordinate system variable.
void | setUnitMember (const Unit &unit)
| Set the unit variable.
void | setMiscInfoMember (const RecordInterface &rec)
| Set the miscinfo variable.
RegionHandler * | getRegionHandler ()
| Get access to the region handler.
Protected Member Functions inherited from casacore::MaskedLattice< Float >
MaskedLattice< Float > & | operator= (const MaskedLattice< Float > &)
| Assignment can only be used by derived classes.
Protected Member Functions inherited from casacore::Lattice< Float >
void | handleMathTo (Lattice< Bool > &, int) const
| Lattice ()
| Define default constructor to satisfy compiler.
virtual void | handleMath (const Lattice< Float > &from, int oper)
| Handle the Math operators (+=, -=, *=, /=).
Lattice< Float > & | operator= (const Lattice< Float > &)
Protected Member Functions inherited from casacore::LatticeBase
| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Detailed Description

Class providing native access to FITS Error images.

### Intended use:

Public interface

### Review Status

Test programs:
  tFITSErrorImage

### Prerequisite

- FITSImage
- FITSMask

### Etymology

### Synopsis

### Example

### Motivation

This provides native access to FITS error images.

Definition at line 75 of file FITSErrorImage.h.

## Member Enumeration Documentation

## ErrorType

enum casacore::FITSErrorImage::ErrorType

The enum describes which types of error images exist.

The type is fixed during object creation and can not be changed at a later time.

Enumerator
MSE |
RMSE |
INVMSE |
INVRMSE |
UNKNOWN |
DEFAULT |

Definition at line 81 of file FITSErrorImage.h.

## Constructor & Destructor Documentation

## FITSErrorImage() [1/3]

casacore::FITSErrorImage::FITSErrorImage | ( | const String & | name,
|  | uInt | whichRep = 0,
|  | uInt | whichHDU = 0,
|  | FITSErrorImage::ErrorType | errtype = MSE )

explicit

Construct a FITSImage from the disk FITS file name and extension and apply mask.

References MSE, casacore::FITSImage::name(), and casacore::FITSImage::whichHDU().

Referenced by FITSErrorImage(), and operator=().

## FITSErrorImage() [2/3]

casacore::FITSErrorImage::FITSErrorImage | ( | const String & | name,
|  | const MaskSpecifier & | mask,
|  | uInt | whichRep = 0,
|  | uInt | whichHDU = 0,
|  | FITSErrorImage::ErrorType | errtype = MSE )

Construct a FITSImage from the disk FITS file name and extension and apply mask or not.

References casacore::mask(), MSE, casacore::FITSImage::name(), and casacore::FITSImage::whichHDU().

## FITSErrorImage() [3/3]

casacore::FITSErrorImage::FITSErrorImage | ( | const FITSErrorImage & | other | ) |

Copy constructor (reference semantics).

References FITSErrorImage().

## ~FITSErrorImage()

virtual casacore::FITSErrorImage::~FITSErrorImage | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## cloneII()

virtual ImageInterface< Float > * casacore::FITSErrorImage::cloneII | ( |  | ) | const

virtual

Make a copy of the object with new (reference semantics).

Reimplemented from casacore::FITSImage.

## doGetSlice()

virtual Bool casacore::FITSErrorImage::doGetSlice | ( | Array< Float > & | buffer,
|  | const Slicer & | theSlice )

virtual

Do the actual get of the data.

Returns False as the data do not reference another Array

Reimplemented from casacore::FITSImage.

## doPutSlice()

virtual void casacore::FITSErrorImage::doPutSlice | ( | const Array< Float > & | sourceBuffer,
|  | const IPosition & | where,
|  | const IPosition & | stride )

virtual

The FITSImage is not writable, so this throws an exception.

Reimplemented from casacore::FITSImage.

## errorType()

virtual FITSErrorImage::ErrorType casacore::FITSErrorImage::errorType | ( |  | ) | const

inline virtual

Return the error type.

Definition at line 122 of file FITSErrorImage.h.

References errtype_p.

## errorTypeToString()

String casacore::FITSErrorImage::errorTypeToString | ( | FITSErrorImage::ErrorType | errType | ) |

static

Convert a String to an image type.

## imageType()

virtual String casacore::FITSErrorImage::imageType | ( |  | ) | const

virtual

Get the image type (returns "FITSErrorImage").

Reimplemented from casacore::FITSImage.

## operator=()

FITSErrorImage & casacore::FITSErrorImage::operator= | ( | const FITSErrorImage & | other | ) |

Assignment (reference semantics).

References FITSErrorImage().

## setupMask()

void casacore::FITSErrorImage::setupMask | ( |  | ) |

private

Set the correct masking.

## stringToErrorType()

FITSErrorImage::ErrorType casacore::FITSErrorImage::stringToErrorType | ( | String | errorTypeStr | ) |

static

Convert an image type to String.

## Member Data Documentation

## buffer_p

Array<Float> casacore::FITSErrorImage::buffer_p

private

Definition at line 136 of file FITSErrorImage.h.

## errtype_p

FITSErrorImage::ErrorType casacore::FITSErrorImage::errtype_p

private

Definition at line 137 of file FITSErrorImage.h.

Referenced by errorType().

The documentation for this class was generated from the following file:

- images/Images/FITSErrorImage.h